FirstChanceExceptionEventArgs FirstChanceExceptionEventArgs FirstChanceExceptionEventArgs FirstChanceExceptionEventArgs Class

Definizione

Fornisce dati per l'evento di notifica generato quando si verifica per la prima volta un'eccezione gestita, prima che Common Language Runtime inizi la ricerca di gestori di eventi.Provides data for the notification event that is raised when a managed exception first occurs, before the common language runtime begins searching for event handlers.

public ref class FirstChanceExceptionEventArgs : EventArgs
public class FirstChanceExceptionEventArgs : EventArgs
type FirstChanceExceptionEventArgs = class
    inherit EventArgs
Public Class FirstChanceExceptionEventArgs
Inherits EventArgs
Ereditarietà
FirstChanceExceptionEventArgsFirstChanceExceptionEventArgsFirstChanceExceptionEventArgsFirstChanceExceptionEventArgs

Esempi

L'esempio seguente crea una serie di domini dell'applicazione denominata Child_0 attraverso Child_3, con un Worker oggetto in ogni dominio applicazione.The following example creates a series of application domains named Child_0 through Child_3, with a Worker object in each application domain. Ogni Worker oggetto ha un riferimento al Worker dell'oggetto nel dominio dell'applicazione Avanti, fatta eccezione per il Worker nel dominio dell'applicazione ultimo.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. Il FirstChanceException evento viene gestito in tutti i domini applicazione, ad eccezione Child_1.The FirstChanceException event is handled in all application domains except Child_1.

Quando sono stati creati i domini applicazione, il dominio applicazione predefinito chiama il TestException metodo per il primo dominio dell'applicazione figlio.When the application domains have been created, the default application domain calls the TestException method for the first child application domain. Ciascun Worker object chiama il TestException metodo successivo, finché l'ultimo Worker genera un'eccezione che viene o non gestita.Each Worker object calls the TestException method for the next, until the last Worker throws an exception that is either handled or unhandled. Di conseguenza, il thread corrente attraversa tutti i domini dell'applicazione e TestException viene aggiunta allo stack in ogni dominio applicazione.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

Quando l'ultima Worker oggetto gestisce l'eccezione, il FirstChanceException evento viene generato solo nel dominio dell'applicazione ultimo.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. Gli altri domini applicazione mai l'opportunità di gestire l'eccezione, pertanto non viene generato l'evento.The other application domains never get a chance to handle the exception, so the event is not raised.

Quando l'ultima Worker oggetto non gestisce l'eccezione, il FirstChanceException in ogni dominio applicazione che dispone di un gestore di evento viene generato l'evento.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. Al termine di ogni gestore eventi, lo stack continua a di rimozione fino a quando non viene rilevata l'eccezione per il dominio applicazione predefinito.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

Nota

Per visualizzare la modalità di visualizzazione dello stack aumenta man mano che viene generato l'evento più vicino e più prossimo al dominio applicazione predefinito, modificare e.Exception.Message al e.Exception nel FirstChanceHandler gestori eventi.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. Si noti che quando TestException viene chiamato attraverso i limiti del dominio applicazione, viene visualizzato due volte: una volta per il proxy e una volta per lo stub.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

Commenti

Questa classe fornisce il gestore di eccezioni per il AppDomain.FirstChanceException evento con accesso all'eccezione.This class provides the exception handler for the AppDomain.FirstChanceException event with access to the exception.

Costruttori

FirstChanceExceptionEventArgs(Exception) FirstChanceExceptionEventArgs(Exception) FirstChanceExceptionEventArgs(Exception) FirstChanceExceptionEventArgs(Exception)

Inizializza una nuova istanza della classe FirstChanceExceptionEventArgs con un’eccezione specificata.Initializes a new instance of the FirstChanceExceptionEventArgs class with a specified exception.

Proprietà

Exception Exception Exception Exception

Oggetto eccezione gestita che corrisponde all'eccezione generata nel codice gestito.The managed exception object that corresponds to the exception thrown in managed code.

Metodi

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

Determina se l'oggetto specificato è uguale all'oggetto corrente.Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

Funge da funzione hash predefinita.Serves as the default hash function.

(Inherited from Object)
GetType() GetType() GetType() GetType()

Ottiene l'oggetto Type dell'istanza corrente.Gets the Type of the current instance.

(Inherited from Object)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

Crea una copia superficiale dell'oggetto Object corrente.Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

Restituisce una stringa che rappresenta l'oggetto corrente.Returns a string that represents the current object.

(Inherited from Object)

Si applica a

Vedi anche